<script lang="ts">
  import type { Bundle, Environment, PveConfig } from '@models/Sandbox';
  import { Badge } from '@sveltestrap/sveltestrap';
  import { environmentIsRunning } from '@models/Sandbox.js';
  import ChallengeControls from '@components/Sandbox/ChallengeControls.svelte';
  import Markdown from '@components/Markdown/Markdown.svelte';
  export let updateChallenges;
  export let pveConfig: PveConfig;
  export let bundle: Bundle;
  export let environment: Environment;

  // What content to display in the body of the card
  let content: 'description' | 'how_to_play' | 'resources' = 'description';
</script>

<div class="card h-100">
  <div class="card-header">
    <span class="card-title font h4">{bundle.name}</span>
    <span class="card-subtitle text-muted mx-1">by C2 Games</span>
    {#if environment}
      <Badge color="info">Deployed</Badge>
    {/if}
    {#if environmentIsRunning(environment)}
      <Badge color="success">Running</Badge>
    {/if}
    <!-- todo add this once we are able to track user progression -->
    <!-- <Badge color="secondary">Completed</Badge> -->
    {#if !bundle.active}
      <!-- students should never see disabled bundles -->
      <Badge color="warning">Disabled</Badge>
    {/if}
    <div class="btn-group ms-auto float-end">
      <a
        on:click={() => (content = 'description')}
        class="clickable btn {content === 'description' ? 'btn-info' : 'btn-outline-info'}"
      >
        Description
      </a>
      <a
        on:click={() => (content = 'how_to_play')}
        class="clickable btn {content === 'how_to_play' ? 'btn-info' : 'btn-outline-info'}"
      >
        How to Play
      </a>
      {#if bundle.resources?.length}
        <a
          on:click={() => (content = 'resources')}
          class="clickable btn {content === 'resources' ? 'btn-info' : 'btn-outline-info'}"
        >
          Supporting Resources
        </a>
      {/if}
    </div>
  </div>
  <div class="card-body">
    {#if content === 'resources'}
      <ul>
        {#each (bundle.resources || []).sort((a, b) => a.order - b.order) as resource}
          <li><a target="_blank" href={resource.url}>{resource.title}</a></li>
        {/each}
      </ul>
    {:else}
      <Markdown source={bundle[content] || 'Uh oh, no content here!'} />
    {/if}
  </div>
  <div class="card-footer">
    <ChallengeControls {updateChallenges} {pveConfig} {bundle} {environment} />
  </div>
</div>
